//
//  Copyright (C) 2004,  . All Rights Reserved.
//
//  PROJECT:    aggressor/victim sample
//
//  MODULE:     other_process.cpp
//
//  PURPOSE:     ,      
//                dll   
//
//  AUTHOR(S):   
//
//  PLATFORMS:  Windows NT/2000/XP
//

#include <windows.h>
#include "other_process.h"
#include "process_buffer.h"
#include <memory>

namespace OtherProcess
{
	int GetExportSectionRVA(HANDLE hProcess, const char* baseAddress);

	int FindName(
			HANDLE hProcess, 
			const char* baseAddress, 
			DWORD AddressOfNames, 
			DWORD count, 
			const char* name);
}

//////////////////////////////////////////////////////////////////////////
//
//  
//
//////////////////////////////////////////////////////////////////////////

//  
//  FUNCTION:     HANDLE AsynchronousCall(HANDLE, void*, void*, DWORD* )
//
//  PARAMETERS:   [IN]  hProcess  -  
//                [IN]  address   -  
//                [IN]  parameter -  
//                [OUT] pid       - id 
//
//  RETURN VALUE:    NULL
//
//  REVISION:     17.09.2004   
//
//  PURPOSE:          ,  
//                 ,    
//
//  COMMENTS:     pid     NULL
// 
HANDLE OtherProcess::AsynchronousCall(HANDLE hProcess, void* address, void* parameter, DWORD* pid)
{
	DWORD id;
	HANDLE hThread;

	//     .
	hThread = CreateRemoteThread(
					hProcess, 
					0, 
					0, 
					(LPTHREAD_START_ROUTINE)address, 
					parameter, 
					0, 
					&id);

	if (pid)
	{
		*pid = id;
	}

	return hThread;
}

//  
//  FUNCTION:     bool SynchronousCall(HANDLE, void*, void*, DWORD* )
//
//  PARAMETERS:   [IN]  hProcess  -  
//                [IN]  address   -  
//                [IN]  parameter -  
//                [OUT] result    -  
//
//  RETURN VALUE: /
//
//  REVISION:     17.09.2004   
//
//  PURPOSE:          ,    
//
//  COMMENTS:     result     NULL
// 
bool OtherProcess::SynchronousCall(HANDLE hProcess, void* address, void* parameter, DWORD* result)
{
	//  
	HANDLE hThread = AsynchronousCall(hProcess, address, parameter, 0);

	if (!hThread)
	{
		//  
		return false;
	}

	//    
	if (WaitForSingleObject(hThread, INFINITE) != WAIT_OBJECT_0)
	{
		CloseHandle(hThread);
		return false;
	}

	if (result)
	{
		DWORD code;

		//    
		if (!GetExitCodeThread(hThread, &code))
		{
			CloseHandle(hThread);
			return false;
		}

		*result = code;
	}

	CloseHandle(hThread);
	return true;
}

//  
//  FUNCTION:     HMODULE LoadLibrary(HANDLE , const TCHAR* )
//
//  PARAMETERS:   [IN] hProcess  -  
//                [IN] path      -   dll
//
//  RETURN VALUE: HMODULE  dll     NULL
//
//  REVISION:     17.09.2004   
//
//  PURPOSE:       dll   
//
//  COMMENTS:     
// 
HMODULE OtherProcess::LoadLibrary(HANDLE hProcess, const TCHAR* path)
{
	int size = (lstrlen(path) + 1) * sizeof(TCHAR);

	//    
	CProcessBuffer buffer(hProcess);

	if (!buffer.alloc(size))
	{
		return 0;
	}

	if (!buffer.write(0, path, size))
	{
		return 0;
	}

	//   kernel32.dll
	HMODULE hKernel32 = GetModuleHandle(TEXT("kernel32.dll"));

	//    ,      (ASCII/UNICODE)
	//    LoadLibraryA/W
#ifndef UNICODE
	void* pLoadLibrary = ::GetProcAddress(hKernel32, "LoadLibraryA");
#else //UNICODE
	void* pLoadLibrary = ::GetProcAddress(hKernel32, "LoadLibraryW");
#endif //UNICODE

	DWORD code;

	//      
	if (!SynchronousCall(hProcess, pLoadLibrary, buffer.get(), &code))
	{
		//  
		return 0;
	}

	// !
	return reinterpret_cast<HMODULE>(code);
}

//  
//  FUNCTION:     void FreeLibrary(HANDLE , HMODULE )
//
//  PARAMETERS:   [IN] hProcess  -  
//                [IN] hLib      - HMODULE  dll   
//
//  RETURN VALUE: 
//
//  REVISION:     17.09.2004   
//
//  PURPOSE:       dll   
//
//  COMMENTS:     
// 
void OtherProcess::FreeLibrary(HANDLE hProcess, HMODULE hLib)
{
	//   kernel32.dll
	HMODULE hKernel32 = GetModuleHandle(TEXT("kernel32.dll"));

	//  FreeLibrary
	void* pFreeLibrary = ::GetProcAddress(hKernel32, "FreeLibrary");

	//      
	SynchronousCall(hProcess, pFreeLibrary, hLib, 0);
}

//  
//  FUNCTION:     void* GetProcAddress(HANDLE , HMODULE, const char* )
//
//  PARAMETERS:   [IN] hProcess  -  
//                [IN] hLib      - HMODULE dll   
//                [IN] name      -  
//
//  RETURN VALUE:       NULL
//
//  REVISION:     17.09.2004   
//
//  PURPOSE:           dll   
//
//  COMMENTS:     
// 
void* OtherProcess::GetProcAddress(HANDLE hProcess, HMODULE hLib, const char* name)
{
    //     !   
    // LoadLibrary   ..
    char* baseAddress = reinterpret_cast<char*>
                             (reinterpret_cast<DWORD>(hLib) & 0xFFFF0000);

    //   
    int export_offset = GetExportSectionRVA(hProcess, baseAddress);

    if (export_offset <= 0)
    {
        // -   
        return 0;
    }

    //    
    IMAGE_EXPORT_DIRECTORY export;
    if (!ReadProcessMemory(
            hProcess, 
            baseAddress + export_offset, 
            &export, 
            sizeof(export), 
            0))
	{
		//  
		return 0;
	}

    //    
    WORD funcIndex = -1;

    if (reinterpret_cast<DWORD_PTR>(name) > 0x0000ffff)
    {
        //    .  
        int nameIndex = FindName(
                            hProcess, 
                            baseAddress, 
                            export.AddressOfNames, 
                            export.NumberOfNames, 
                            name);

        if (nameIndex < 0)
        {
            //   
            return 0;
        }

        //   ( !!!)
        if (!ReadProcessMemory(
				hProcess,
	            baseAddress + export.AddressOfNameOrdinals 
                    + nameIndex * sizeof(WORD), 
		        &funcIndex, 
			    sizeof(funcIndex), 
				0))
		{
			return 0;
		}
    }
    else
    {
        //    
        WORD funcOrdinal = reinterpret_cast<DWORD>(name);

        if ((funcOrdinal < export.Base) 
         || (funcOrdinal >= export.Base + export.NumberOfFunctions))
        {
            //   
            return 0;
        }

        funcIndex = funcOrdinal - export.Base;
    }

    if ((funcIndex < 0) || (funcIndex >= export.NumberOfFunctions))
    {
        //   
        return 0;
    }

    //  
    DWORD funcRVA;
    if (!ReadProcessMemory(
            hProcess,
            baseAddress + export.AddressOfFunctions + funcIndex * sizeof(DWORD), 
            &funcRVA, 
            sizeof(funcRVA), 
            0))
	{
		return 0;
	}

    //     + RVA
    return (baseAddress + funcRVA);
}


//////////////////////////////////////////////////////////////////////////
//
//  
//
//////////////////////////////////////////////////////////////////////////

//  RVA  
//  -1.   
int OtherProcess::GetExportSectionRVA(HANDLE hProcess, const char* baseAddress)
{
	//  DOS-
	IMAGE_DOS_HEADER dos_header;
	
	if (!ReadProcessMemory(
			hProcess, 
			baseAddress, 
			&dos_header, 
			sizeof(dos_header), 
			0))
	{
		return -1;
	}

	//  PE-
	IMAGE_NT_HEADERS pe_header;

	if (!ReadProcessMemory(
			hProcess, 
			baseAddress + dos_header.e_lfanew, 
			&pe_header, 
			sizeof(pe_header), 
			0))
	{
		return -1;
	}

	//   
	return pe_header.OptionalHeader.DataDirectory
						[IMAGE_DIRECTORY_ENTRY_EXPORT].VirtualAddress;
}

//    ,    
//  -1  -     
int OtherProcess::FindName(
					HANDLE hProcess, 
					const char* baseAddress, 
					DWORD AddressOfNames, 
					DWORD count, 
					const char* name)
{
	//      ,     
	int size = lstrlenA(name) + 1;
	std::auto_ptr<char> candidate(new char[size]);

	//      
	for (int index = 0; index < count; index++)
	{
		DWORD nameRVA;

		//    
		if (!ReadProcessMemory(
				hProcess,
				baseAddress + AddressOfNames + index * sizeof(DWORD), 
				&nameRVA, 
				sizeof(nameRVA), 
				0))
		{
			return -1;
		}
			
		//  
		if (ReadProcessMemory(
				hProcess,
				baseAddress + nameRVA, 
				candidate.get(), 
				size, 
				0))
		{
			return -1;
		}
		
		if (strcmp(name, candidate.get()) == 0)
		{
			// !  :)
			return index;
		}
	}

	//   
	return -1;
}

//////////////////////////////////////////////////////////////////////////
